var express = require('express');
var server = express();
var bodyParser = require('body-parser');
var path = require('path');
var fs = require('fs-extra');
var multer = require('multer');
var upload = multer({dest: 'public'}).single("file");
var PersonalityInsightsV3 = require('watson-developer-cloud/personality-insights/v3');

server.use(bodyParser.urlencoded({extended: true}));
server.use(bodyParser.json());
server.use(express.static(path.join(__dirname, 'public')));

var personalityInsights = new PersonalityInsightsV3({
  username: 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx',
  password: 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx',
  version: '2017-10-13',
  url: 'https://gateway.watsonplatform.net/personality-insights/api'
});

server.get('/', function (req, res) {
  res.sendFile(__dirname + "/index.html");
});

server.post('/api/file', function (req, res, next) {
  upload(req, res, function (err) {
    var file = fs.readFileSync(req.file.path);
    var params = {
      content: file.toString('UTF-8'),
      content_language: 'ja',
      content_type: 'text/plain',
      accept_language: 'ja'
    };

    personalityInsights.profile(
      params,
      function (err, response) {
        if (err) {
          console.log(err);
        } else {
          res.json(response);
        }
      }
    );
  })
});

server.post('/api/text', function (req, res, next) {
  var params = {
    content: req.body.textarea,
    content_language: 'ja',
    content_type: 'text/plain',
    accept_language: 'ja'
  };

  personalityInsights.profile(
    params,
    function (err, response) {
      if (err) {
        console.log(err);
      } else {
        res.json(response);
      }
    }
  );
});

server.listen(8000, function () {
  console.log('Listening on port 8000');
});
